-- Copyright (C) 2022  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- VENDOR "Altera"
-- PROGRAM "Quartus Prime"
-- VERSION "Version 22.1std.0 Build 915 10/25/2022 SC Lite Edition"

-- DATE "04/26/2023 13:54:36"

-- 
-- Device: Altera 5CSEMA5F31C6 Package FBGA896
-- 

-- 
-- This VHDL file should be used for Active-HDL (VHDL) only
-- 

LIBRARY ALTERA_LNSIM;
LIBRARY CYCLONEV;
LIBRARY IEEE;
USE ALTERA_LNSIM.ALTERA_LNSIM_COMPONENTS.ALL;
USE CYCLONEV.CYCLONEV_COMPONENTS.ALL;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY 	fourbit_adder IS
    PORT (
	a : IN std_logic_vector(3 DOWNTO 0);
	b : IN std_logic_vector(3 DOWNTO 0);
	z : BUFFER std_logic_vector(3 DOWNTO 0);
	cout : BUFFER std_logic
	);
END fourbit_adder;

-- Design Ports Information
-- z[0]	=>  Location: PIN_AC22,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- z[1]	=>  Location: PIN_AK29,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- z[2]	=>  Location: PIN_AD21,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- z[3]	=>  Location: PIN_AG26,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- cout	=>  Location: PIN_AA20,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- a[0]	=>  Location: PIN_AC23,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- b[0]	=>  Location: PIN_AH27,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- a[1]	=>  Location: PIN_AK28,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- b[1]	=>  Location: PIN_Y19,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- a[2]	=>  Location: PIN_AF26,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- b[2]	=>  Location: PIN_AF25,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- a[3]	=>  Location: PIN_AD20,	 I/O Standard: 2.5 V,	 Current Strength: Default
-- b[3]	=>  Location: PIN_V18,	 I/O Standard: 2.5 V,	 Current Strength: Default


ARCHITECTURE structure OF fourbit_adder IS
SIGNAL gnd : std_logic := '0';
SIGNAL vcc : std_logic := '1';
SIGNAL unknown : std_logic := 'X';
SIGNAL devoe : std_logic := '1';
SIGNAL devclrn : std_logic := '1';
SIGNAL devpor : std_logic := '1';
SIGNAL ww_devoe : std_logic;
SIGNAL ww_devclrn : std_logic;
SIGNAL ww_devpor : std_logic;
SIGNAL ww_a : std_logic_vector(3 DOWNTO 0);
SIGNAL ww_b : std_logic_vector(3 DOWNTO 0);
SIGNAL ww_z : std_logic_vector(3 DOWNTO 0);
SIGNAL ww_cout : std_logic;
SIGNAL \~QUARTUS_CREATED_GND~I_combout\ : std_logic;
SIGNAL \a[0]~input_o\ : std_logic;
SIGNAL \b[0]~input_o\ : std_logic;
SIGNAL \b_adder0|sum~0_combout\ : std_logic;
SIGNAL \a[1]~input_o\ : std_logic;
SIGNAL \b[1]~input_o\ : std_logic;
SIGNAL \b_adder1|sum~combout\ : std_logic;
SIGNAL \b[2]~input_o\ : std_logic;
SIGNAL \a[2]~input_o\ : std_logic;
SIGNAL \b_adder2|sum~combout\ : std_logic;
SIGNAL \b_adder1|cout~0_combout\ : std_logic;
SIGNAL \a[3]~input_o\ : std_logic;
SIGNAL \b[3]~input_o\ : std_logic;
SIGNAL \b_adder3|sum~combout\ : std_logic;
SIGNAL \b_adder3|cout~0_combout\ : std_logic;
SIGNAL \b_adder1|ALT_INV_cout~0_combout\ : std_logic;
SIGNAL \ALT_INV_a[0]~input_o\ : std_logic;
SIGNAL \ALT_INV_b[0]~input_o\ : std_logic;
SIGNAL \ALT_INV_a[1]~input_o\ : std_logic;
SIGNAL \ALT_INV_b[1]~input_o\ : std_logic;
SIGNAL \ALT_INV_a[2]~input_o\ : std_logic;
SIGNAL \ALT_INV_b[2]~input_o\ : std_logic;
SIGNAL \ALT_INV_a[3]~input_o\ : std_logic;
SIGNAL \ALT_INV_b[3]~input_o\ : std_logic;

BEGIN

ww_a <= a;
ww_b <= b;
z <= ww_z;
cout <= ww_cout;
ww_devoe <= devoe;
ww_devclrn <= devclrn;
ww_devpor <= devpor;
\b_adder1|ALT_INV_cout~0_combout\ <= NOT \b_adder1|cout~0_combout\;
\ALT_INV_a[0]~input_o\ <= NOT \a[0]~input_o\;
\ALT_INV_b[0]~input_o\ <= NOT \b[0]~input_o\;
\ALT_INV_a[1]~input_o\ <= NOT \a[1]~input_o\;
\ALT_INV_b[1]~input_o\ <= NOT \b[1]~input_o\;
\ALT_INV_a[2]~input_o\ <= NOT \a[2]~input_o\;
\ALT_INV_b[2]~input_o\ <= NOT \b[2]~input_o\;
\ALT_INV_a[3]~input_o\ <= NOT \a[3]~input_o\;
\ALT_INV_b[3]~input_o\ <= NOT \b[3]~input_o\;

-- Location: IOOBUF_X86_Y0_N2
\z[0]~output\ : cyclonev_io_obuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	open_drain_output => "false",
	shift_series_termination_control => "false")
-- pragma translate_on
PORT MAP (
	i => \b_adder0|sum~0_combout\,
	devoe => ww_devoe,
	o => ww_z(0));

-- Location: IOOBUF_X82_Y0_N93
\z[1]~output\ : cyclonev_io_obuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	open_drain_output => "false",
	shift_series_termination_control => "false")
-- pragma translate_on
PORT MAP (
	i => \b_adder1|sum~combout\,
	devoe => ww_devoe,
	o => ww_z(1));

-- Location: IOOBUF_X82_Y0_N59
\z[2]~output\ : cyclonev_io_obuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	open_drain_output => "false",
	shift_series_termination_control => "false")
-- pragma translate_on
PORT MAP (
	i => \b_adder2|sum~combout\,
	devoe => ww_devoe,
	o => ww_z(2));

-- Location: IOOBUF_X84_Y0_N36
\z[3]~output\ : cyclonev_io_obuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	open_drain_output => "false",
	shift_series_termination_control => "false")
-- pragma translate_on
PORT MAP (
	i => \b_adder3|sum~combout\,
	devoe => ww_devoe,
	o => ww_z(3));

-- Location: IOOBUF_X84_Y0_N19
\cout~output\ : cyclonev_io_obuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	open_drain_output => "false",
	shift_series_termination_control => "false")
-- pragma translate_on
PORT MAP (
	i => \b_adder3|cout~0_combout\,
	devoe => ww_devoe,
	o => ww_cout);

-- Location: IOIBUF_X86_Y0_N18
\a[0]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_a(0),
	o => \a[0]~input_o\);

-- Location: IOIBUF_X84_Y0_N52
\b[0]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_b(0),
	o => \b[0]~input_o\);

-- Location: LABCELL_X85_Y1_N30
\b_adder0|sum~0\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder0|sum~0_combout\ = !\a[0]~input_o\ $ (!\b[0]~input_o\)

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0000111111110000000011111111000000001111111100000000111111110000",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	datac => \ALT_INV_a[0]~input_o\,
	datad => \ALT_INV_b[0]~input_o\,
	combout => \b_adder0|sum~0_combout\);

-- Location: IOIBUF_X82_Y0_N75
\a[1]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_a(1),
	o => \a[1]~input_o\);

-- Location: IOIBUF_X84_Y0_N1
\b[1]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_b(1),
	o => \b[1]~input_o\);

-- Location: LABCELL_X85_Y1_N39
\b_adder1|sum\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder1|sum~combout\ = ( \b[0]~input_o\ & ( !\a[1]~input_o\ $ (!\b[1]~input_o\ $ (\a[0]~input_o\)) ) ) # ( !\b[0]~input_o\ & ( !\a[1]~input_o\ $ (!\b[1]~input_o\) ) )

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0101101001011010010110101010010101011010010110100101101010100101",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	dataa => \ALT_INV_a[1]~input_o\,
	datac => \ALT_INV_b[1]~input_o\,
	datad => \ALT_INV_a[0]~input_o\,
	datae => \ALT_INV_b[0]~input_o\,
	combout => \b_adder1|sum~combout\);

-- Location: IOIBUF_X86_Y0_N35
\b[2]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_b(2),
	o => \b[2]~input_o\);

-- Location: IOIBUF_X86_Y0_N52
\a[2]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_a(2),
	o => \a[2]~input_o\);

-- Location: LABCELL_X85_Y1_N12
\b_adder2|sum\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder2|sum~combout\ = ( \b[0]~input_o\ & ( \a[2]~input_o\ & ( !\b[2]~input_o\ $ (((!\a[1]~input_o\ & (\b[1]~input_o\ & \a[0]~input_o\)) # (\a[1]~input_o\ & ((\a[0]~input_o\) # (\b[1]~input_o\))))) ) ) ) # ( !\b[0]~input_o\ & ( \a[2]~input_o\ & ( 
-- !\b[2]~input_o\ $ (((\a[1]~input_o\ & \b[1]~input_o\))) ) ) ) # ( \b[0]~input_o\ & ( !\a[2]~input_o\ & ( !\b[2]~input_o\ $ (((!\a[1]~input_o\ & ((!\b[1]~input_o\) # (!\a[0]~input_o\))) # (\a[1]~input_o\ & (!\b[1]~input_o\ & !\a[0]~input_o\)))) ) ) ) # ( 
-- !\b[0]~input_o\ & ( !\a[2]~input_o\ & ( !\b[2]~input_o\ $ (((!\a[1]~input_o\) # (!\b[1]~input_o\))) ) ) )

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0001000111101110000101111110100011101110000100011110100000010111",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	dataa => \ALT_INV_a[1]~input_o\,
	datab => \ALT_INV_b[1]~input_o\,
	datac => \ALT_INV_a[0]~input_o\,
	datad => \ALT_INV_b[2]~input_o\,
	datae => \ALT_INV_b[0]~input_o\,
	dataf => \ALT_INV_a[2]~input_o\,
	combout => \b_adder2|sum~combout\);

-- Location: LABCELL_X85_Y1_N18
\b_adder1|cout~0\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder1|cout~0_combout\ = ( \b[0]~input_o\ & ( \a[0]~input_o\ & ( (\a[1]~input_o\) # (\b[1]~input_o\) ) ) ) # ( !\b[0]~input_o\ & ( \a[0]~input_o\ & ( (\b[1]~input_o\ & \a[1]~input_o\) ) ) ) # ( \b[0]~input_o\ & ( !\a[0]~input_o\ & ( (\b[1]~input_o\ & 
-- \a[1]~input_o\) ) ) ) # ( !\b[0]~input_o\ & ( !\a[0]~input_o\ & ( (\b[1]~input_o\ & \a[1]~input_o\) ) ) )

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0000001100000011000000110000001100000011000000110011111100111111",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	datab => \ALT_INV_b[1]~input_o\,
	datac => \ALT_INV_a[1]~input_o\,
	datae => \ALT_INV_b[0]~input_o\,
	dataf => \ALT_INV_a[0]~input_o\,
	combout => \b_adder1|cout~0_combout\);

-- Location: IOIBUF_X82_Y0_N41
\a[3]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_a(3),
	o => \a[3]~input_o\);

-- Location: IOIBUF_X80_Y0_N1
\b[3]~input\ : cyclonev_io_ibuf
-- pragma translate_off
GENERIC MAP (
	bus_hold => "false",
	simulate_z_as => "z")
-- pragma translate_on
PORT MAP (
	i => ww_b(3),
	o => \b[3]~input_o\);

-- Location: LABCELL_X85_Y1_N33
\b_adder3|sum\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder3|sum~combout\ = ( \b[3]~input_o\ & ( !\a[3]~input_o\ $ (((!\a[2]~input_o\ & (\b_adder1|cout~0_combout\ & \b[2]~input_o\)) # (\a[2]~input_o\ & ((\b[2]~input_o\) # (\b_adder1|cout~0_combout\))))) ) ) # ( !\b[3]~input_o\ & ( !\a[3]~input_o\ $ 
-- (((!\a[2]~input_o\ & ((!\b_adder1|cout~0_combout\) # (!\b[2]~input_o\))) # (\a[2]~input_o\ & (!\b_adder1|cout~0_combout\ & !\b[2]~input_o\)))) ) )

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0001011111101000000101111110100011101000000101111110100000010111",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	dataa => \ALT_INV_a[2]~input_o\,
	datab => \b_adder1|ALT_INV_cout~0_combout\,
	datac => \ALT_INV_b[2]~input_o\,
	datad => \ALT_INV_a[3]~input_o\,
	dataf => \ALT_INV_b[3]~input_o\,
	combout => \b_adder3|sum~combout\);

-- Location: LABCELL_X85_Y1_N54
\b_adder3|cout~0\ : cyclonev_lcell_comb
-- Equation(s):
-- \b_adder3|cout~0_combout\ = ( \a[3]~input_o\ & ( \b_adder1|cout~0_combout\ & ( ((\b[2]~input_o\) # (\a[2]~input_o\)) # (\b[3]~input_o\) ) ) ) # ( !\a[3]~input_o\ & ( \b_adder1|cout~0_combout\ & ( (\b[3]~input_o\ & ((\b[2]~input_o\) # (\a[2]~input_o\))) ) 
-- ) ) # ( \a[3]~input_o\ & ( !\b_adder1|cout~0_combout\ & ( ((\a[2]~input_o\ & \b[2]~input_o\)) # (\b[3]~input_o\) ) ) ) # ( !\a[3]~input_o\ & ( !\b_adder1|cout~0_combout\ & ( (\b[3]~input_o\ & (\a[2]~input_o\ & \b[2]~input_o\)) ) ) )

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0000000000000011001100110011111100000011001100110011111111111111",
	shared_arith => "off")
-- pragma translate_on
PORT MAP (
	datab => \ALT_INV_b[3]~input_o\,
	datac => \ALT_INV_a[2]~input_o\,
	datad => \ALT_INV_b[2]~input_o\,
	datae => \ALT_INV_a[3]~input_o\,
	dataf => \b_adder1|ALT_INV_cout~0_combout\,
	combout => \b_adder3|cout~0_combout\);

-- Location: LABCELL_X29_Y57_N0
\~QUARTUS_CREATED_GND~I\ : cyclonev_lcell_comb
-- Equation(s):

-- pragma translate_off
GENERIC MAP (
	extended_lut => "off",
	lut_mask => "0000000000000000000000000000000000000000000000000000000000000000",
	shared_arith => "off")
-- pragma translate_on
;
END structure;


